;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w kiery#w i#w j#w zwrot#w zwrotObi#w
		    figura#w akcesoria#w
		    daneAd1-d3#w daneAd1-d2#w daneBd3-d2#w daneBd1-d2#w daneDd3-d1=d2#w
		    daneCd1-d3#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w      
;  rozmiar#w  ("d1mm" "150") ("d3mm" "80") ("Lmm" "140") ("Hmm" "87") ("kgTCPL" "0.5") 
;  kierunki#w (("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P3" "d3mm" "100.00" (151.929 73.3729 0.0)) 
;              ("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P2" "d1mm" "100.00" (158.929 64.6729 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;zaadowanie danych pod odpowiednie zmienne
(foreach i#w wszystkieKierPa#w
(cond

;Ad1-d3
((and (not daneAd1-d3#w)
(or (equal i#w '("P1>P3" "P1>P2")) (equal i#w '("P2>P3" "P2>P1")) ))
     (progn (load (strcat sciezkaPlik#w plik#w "_Ad1-d3.lsp"))
            (setq daneAd1-d3#w (obliczPa1#w)) ))
;Ad1-d2
((and (not daneAd1-d2#w)
(or (equal i#w '("P1>P2" "P1>P3")) (equal i#w '("P2>P1" "P2>P3")) ))
     (progn (load (strcat sciezkaPlik#w plik#w "_Ad1-d2.lsp"))
            (setq daneAd1-d2#w (obliczPa1#w)) ))
;Bd3-d2
((and (not daneBd3-d2#w)
(or (equal i#w '("P3>P2" "P1>P2")) (equal i#w '("P3>P1" "P2>P1")) ))
     (progn (load (strcat sciezkaPlik#w plik#w "_Bd3-d2.lsp"))
            (setq daneBd3-d2#w (obliczPa1#w)) ))
;Bd1-d2
((and (not daneBd1-d2#w)
(or (equal i#w '("P1>P2" "P3>P2")) (equal i#w '("P2>P1" "P3>P1")) ))
     (progn (load (strcat sciezkaPlik#w plik#w "_Bd1-d2.lsp"))
            (setq daneBd1-d2#w (obliczPa1#w)) ))
;Dd3-d1=d2
((and (not daneDd3-d1=d2#w)
(or (equal i#w '("P3>P1" "P3>P2")) (equal i#w '("P3>P2" "P3>P1")) ))
     (progn (load (strcat sciezkaPlik#w plik#w "_Dd3-d1=d2.lsp"))
            (setq daneDd3-d1=d2#w (obliczPa1#w)) ))
;Cd1-d3
((and (not daneCd1-d3#w)
(or (equal i#w '("P1>P3" "P2>P3")) (equal i#w '("P2>P3" "P1>P3")) ))
     (progn (load (strcat sciezkaPlik#w plik#w "_Cd1-d3.lsp"))
            (setq daneCd1-d3#w (obliczPa1#w)) ))

));cond/foreach



;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())
 
(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
	      rozmiar#w  (cadr i#w) 
              kiery#w    (caddr i#w)
              kierunki#w (cadddr i#w) )

;kiery#w - podwojone-odwrcone aby liczy dPa pod warunkiem innego
;te dla drugiego kierunku, trzeciego itd.
(setq p#w      kiery#w
      kiery#w (list kiery#w))
(repeat (- (length p#w) 1) 
        (setq kiery#w (append kiery#w (list
	              (append (list (car (reverse p#w))) (reverse (cdr (reverse p#w))))
))));list/append/setq/repeat


	(setq zwrotObi#w '())
	(foreach j#w kiery#w
	(progn

	(cond
	;Ad1-d3
	((or (equal j#w '("P1>P3" "P1>P2")) (equal j#w '("P2>P3" "P2>P1")) )
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneAd1-d3#w) )))))
	;Ad1-d2
	((or (equal j#w '("P1>P2" "P1>P3")) (equal j#w '("P2>P1" "P2>P3")) )
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneAd1-d2#w) )))))
	;Bd3-d2
	((or (equal j#w '("P3>P2" "P1>P2")) (equal j#w '("P3>P1" "P2>P1")) )
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneBd3-d2#w) )))))
	;Bd1-d2
	((or (equal j#w '("P1>P2" "P3>P2")) (equal j#w '("P2>P1" "P3>P1")) )
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneBd1-d2#w) )))))
	;Dd3-d1=d2
	((or (equal j#w '("P3>P1" "P3>P2")) (equal j#w '("P3>P2" "P3>P1")) )
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneDd3-d1=d2#w) )))))
	;Cd1-d3
	((or (equal j#w '("P1>P3" "P2>P3")) (equal j#w '("P2>P3" "P1>P3")))
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneCd1-d3#w) )))))
	);cond

	));progn/foreach j#w
        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P3" "P2>P3") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P3" "P1>P3") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P3>P1" "P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1" "P3>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w dane#w /  
                   p#w pp#w p1#w p2#w error#w text#w
                   kolejnosc#w d#w d1#w f#w f1#w wyd#w wyd1#w vv#w
		   kierTu#w j#w Vten#w Vxos#w zwrot#w)

;i#w ("P2>P1" "P3>P1")
;rozmiar#w (("d1mm" "100") ("d3mm" "100") ("Lmm" "151") ("Hmm" "65") ("kgTCPL" "0.5"))
;kierunki#w (("P3" "d3mm" "100.00" (120.517 23.9185 0.0) "P1" "d1mm" "200.00" (112.967 
;            30.4185 0.0)) ("P2" "d1mm" "100.00" (128.067 30.4185 0.0) "P1" "d1mm" "200.00" 
;            (112.967 30.4185 0.0)))
;dane#w (("1" "2.2" "1.1") ("1" "2.3" "1.2")...)

(setq p#w (car i#w) p1#w (substr p#w 1 2) p2#w (substr p#w 4 2))
(foreach j#w kierunki#w
(if (and (= (nth 0 j#w) p1#w) (= (nth 4 j#w) p2#w))(setq kierTu#w j#w)))

;rozszyfrowanie wymiaru i obliczenie przekroju
;oraz kolejnosc#w '("1" "2") lub '("2" "1") prdkosci z kierunku w danych z wykresu 
(cond
;Ad1-d3 (V3[m/s], V1[m/s], DPa[Pa])
((or (equal i#w '("P1>P3" "P1>P2")) (equal i#w '("P2>P3" "P2>P1")) )
     (progn     ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w
		      p#w  (nth 5 kierTu#w)
                      d1#w p#w)
		(setq d#w  (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4)  ;[m2]
		      d1#w (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f1#w (/ (* pi (* d1#w d1#w)) 4)) ;[m2]
		;kolejno prdkoci z kierunku "1" "2" w danych z wykresu ("1?2" "1?2" "dPa")
		(setq kolejnosc#w (list "2" "1")
		      text#w "0;Trjn.odejcie")
     ));progn+

;Ad1-d2 (V2[m/s], V1[m/s], DPa[Pa])
((or (equal i#w '("P1>P2" "P1>P3")) (equal i#w '("P2>P1" "P2>P3")) )
     (progn     ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w
		      p#w  (nth 5 kierTu#w)
                      d1#w p#w)
		(setq d#w  (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4)  ;[m2]
		      d1#w (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f1#w (/ (* pi (* d1#w d1#w)) 4)) ;[m2]
		;kolejno prdkoci z kierunku "1" "2" w danych z wykresu ("1?2" "1?2" "dPa")
		(setq kolejnosc#w (list "2" "1")
		      text#w "0;Trjn.przelot")
     ));progn+

;Bd3-d2 (V2[m/s], V3[m/s], DPa[Pa])
((or (equal i#w '("P3>P2" "P1>P2")) (equal i#w '("P3>P1" "P2>P1")) )
     (progn     ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w
		      p#w  (nth 5 kierTu#w)
                      d1#w p#w)
		(setq d#w  (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4)  ;[m2]
		      d1#w (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f1#w (/ (* pi (* d1#w d1#w)) 4)) ;[m2]
		;kolejno prdkoci z kierunku "1" "2" w danych z wykresu ("1?2" "1?2" "dPa")
		(setq kolejnosc#w (list "2" "1")
		      text#w "0;Trjn.dolot")
     ));progn+

;Bd1-d2 (V1[m/s], V2[m/s], DPa[Pa])
((or (equal i#w '("P1>P2" "P3>P2")) (equal i#w '("P2>P1" "P3>P1")) )
     (progn     ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w
		      p#w  (nth 5 kierTu#w)
                      d1#w p#w)
		(setq d#w  (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4)  ;[m2]
		      d1#w (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f1#w (/ (* pi (* d1#w d1#w)) 4)) ;[m2]
		;kolejno prdkoci z kierunku "1" "2" w danych z wykresu ("1?2" "1?2" "dPa")
		(setq kolejnosc#w (list "1" "2")
		      text#w "0;Trjn.przelot")
     ));progn+

;Dd3-d1=d2 (V3[m/s], V1/V2[m/s], DPa[Pa]) - ale zrobi, e nie koniecznie d1=d2
((or (equal i#w '("P3>P1" "P3>P2")) (equal i#w '("P3>P2" "P3>P1")) )
     (progn     ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w
		      p#w  (nth 5 kierTu#w)
                      d1#w p#w)
		(setq d#w  (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4)  ;[m2]
		      d1#w (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f1#w (/ (* pi (* d1#w d1#w)) 4)) ;[m2]
		;kolejno prdkoci z kierunku "1" "2" w danych z wykresu ("1?2" "1?2" "dPa")
		(setq kolejnosc#w (list "1" "2")
		      text#w "0;Trjn.rozejcie")
     ));progn+

;Cd1-d3(V3[m/s], V1[m/s], DPa[Pa])
((or (equal i#w '("P1>P3" "P2>P3")) (equal i#w '("P2>P3" "P1>P3")) )
     (progn     ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w
		      p#w  (nth 5 kierTu#w)
                      d1#w p#w)
		(setq d#w  (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4)  ;[m2]
		      d1#w (/ (atof (cadr (assoc "d1mm" rozmiar#w))) 1000.0) ;[m]
		      f1#w (/ (* pi (* d1#w d1#w)) 4)) ;[m2]
		;kolejno prdkoci z kierunku "1" "2" w danych z wykresu ("1?2" "1?2" "dPa")
		(setq kolejnosc#w (list "2" "1")
		      text#w "0;Trjn.zlot")
     ));progn+

);cond

;obliczenie prdkosci V[m/s] na wlocie i wylocie kierunku
;i ustawienie ich (wg kolejnosc#w) tak jak wystpuj w danych z wykresu
(setq wyd#w  (/ (atof (nth 2 kierTu#w)) 3600)
      wyd1#w (/ (atof (nth 6 kierTu#w)) 3600)) ;[m3/s]
(setq vv#w  (list (/ wyd#w f#w) (/ wyd1#w f1#w) ))

;>>>>>>>>>>>>>>>ponisze mona pomin, wtedy aproksymuje
;sprawdzenie (gdzie dano) czy rozmiar wystpuje w danych z wykresu
;(if (not (member (cdar rozmiar#w) dane#w)) 
;     (setq error#w "Dla tego rozmiaru brak danych na wykresie spadkw ci.!"))

;wywoanie odczytu dPa z tablicy/wykresu
(if (not error#w) 
(setq zwrot#w (LiczyPa_odczytDPa#w  (rtos (nth (- (atoi (nth 0 kolejnosc#w)) 1)  vv#w) 2 12)
    		                    (rtos (nth (- (atoi (nth 1 kolejnosc#w)) 1) vv#w) 2 12)
			            dane#w) ));setq/if not error#w

(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))
(if (and error#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 







