;----------------------------------------------------
;procedura gwna obliczajca spadki cinie elementu
(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w kiery#w i#w j#w zwrot#w zwrotObi#w
                    figura#w akcesoria#w
		    dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w
;  rozmiar#w  (("d1mm" "100") ("obw.m" "0.314") ("pole.m2" "0.008"))
;  kierunki#w (("P1" "d1mm" "100.00" (34.8437 30.4185 0.0) 
;               "P2" "d1mm" "100.00" (47.1028 30.4185 0.0)) 
;  kiery#w    ("P1>P2")
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"



;zaadowanie danych z pliku
(if (not dane#w)
    (progn (load (strcat sciezkaPlik#w plik#w "_PaData.lsp"))
           (setq dane#w (obliczPa1#w)) ))


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())
 
(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
	      rozmiar#w  (cadr i#w) 
              kiery#w    (caddr i#w)
              kierunki#w (cadddr i#w) )
	(setq p#w '())
	(while kiery#w (setq p#w     (append p#w (list (list (car kiery#w))))
			     kiery#w (cdr kiery#w)))
	(setq kiery#w p#w)


	(setq zwrotObi#w '())
	(foreach j#w kiery#w
	(progn

	;Bl90
	(setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		          (liczyPa#w jm_wsp#w j#w rozmiar#w kierunki#w dane#w) ))))

	));progn/foreach j#w
        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o spadkach!") 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!"))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie
(defun liczyPa#w ( jm_wsp#w i#w rozmiar#w kierunki#w dane#w / listaZeStr>#w dmz#w c#w
                   p#w pp#w p1#w p2#w error#w text#w a#w b#w
                   kolejnosc#w d#w dl#w wyd#w
		   kierTu#w j#w zwrot#w wydKratka#w fkratka#w)

;i#w ("P3>P1")
;rozmiar#w (("Ax" "425") ("Bmm" "75") ("d1mm" "100") ("Pnm2" "0.023")) 
;kierunki#w (("P3" "axbmm" "100.00" (120.517 23.9185 0.0) "P1" "d1mm" "200.00" (112.967 
;            30.4185 0.0)) ("P2" "d1mm" "100.00" (128.067 30.4185 0.0) "P1" "d1mm" "200.00" 
;            (112.967 30.4185 0.0)))
;dane#w (("1" "2.2" "1.1") ("1" "2.3" "1.2")...)

(setq p#w (car i#w) p1#w (substr p#w 1 2) p2#w (substr p#w 4 2)) 
(foreach j#w kierunki#w
(if (and (= (nth 0 j#w) p1#w) (= (nth 4 j#w) p2#w))(setq kierTu#w j#w)))


(setq   a#w   (/ (atof (cadr (nth 1 rozmiar#w))) 1000)  ;[m]
	b#w   (/ (atof (cadr (nth 2 rozmiar#w))) 1000)  ;[m]
        fKratka#w   (* 0.9 (* a#w b#w))                ;[m2]
        wydKratka#w (atof (nth 2 kierTu#w))		         ;[m3/h]
        text#w      (strcat "0;Kratka")
);setq


;wywoanie odczytu dPa 
;(Fkr[m2], W[m3/h], DPa[Pa])
(setq zwrot#w (LiczyPa_odczytDPa#w  (rtos fKratka#w 2 12) (rtos wydKratka#w 2 12) dane#w))

(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

zwrot#w   ;'("35.7" "1;Anemostat") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun




