;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
;ELEMENT (jednokierunkowy) W KTRYM dPa ZALENE od innego parametru ni kierunek

(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w rozmiar#w i#w j#w zwrot#w zwrotObi#w kiery#w
		    figura#w akcesoria#w parametr#w 
		    dane80#w dane100#w dane125#w dane160#w dane200#w dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w      
;  rozmiar#w  ("d1mm" "150") ("d3mm" "400") ("Lmm" "140") ("Hmm" "87") ("kgTCPL" "0.5") 
;  kierunki#w (("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P3" "d3mm" "100.00" (151.929 73.3729 0.0)) 
;              ("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P2" "d1mm" "100.00" (158.929 64.6729 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;rekonstrukcja wszystkieKierPa#w poniewa na wybr wykresu ma wpyw inna wielko 
;ni kierunki przepywu
(setq wszystkieKierPa#w '())
(foreach i#w listaDoPa#w (setq wszystkieKierPa#w 
                         (append wszystkieKierPa#w (list (cadar (cadr i#w))))))

;zaadowanie danych pod odpowiednie zmienne
(foreach i#w wszystkieKierPa#w
(cond

;100
((and (not dane100#w)(= i#w "100"))
     (progn (load (strcat sciezkaPlik#w plik#w "_100.lsp"))
            (setq dane100#w (obliczPa1#w)) ))
;125
((and (not dane125#w)(= i#w "125"))
     (progn (load (strcat sciezkaPlik#w plik#w "_125.lsp"))
            (setq dane125#w (obliczPa1#w)) ))
;160
((and (not dane160#w)(= i#w "160"))
     (progn (load (strcat sciezkaPlik#w plik#w "_160.lsp"))
            (setq dane160#w (obliczPa1#w)) ))
;200
((and (not dane200#w)(= i#w "200"))
     (progn (load (strcat sciezkaPlik#w plik#w "_200.lsp"))
            (setq dane200#w (obliczPa1#w)) ))

));cond/foreach


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())

(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
              kiery#w     (caddr i#w)
	      rozmiar#w   (cadr i#w) 
              parametr#w  (cadar rozmiar#w)
 	      kierunki#w  (cadddr i#w)
	      akcesoria#w (cadr (cddddr i#w)) )

	(setq zwrotObi#w '())
	(cond

	;100
	((= parametr#w "100") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane100#w ) 
                             )))))
	;125
	((= parametr#w "125") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane125#w ) 
                             )))))
	;160
	((= parametr#w "160") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane160#w ) 
                             )))))
	;200
	((= parametr#w "200") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane200#w ) 
                             )))))

	;inne - nieliczone rozmiary
	( T                  (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
					akcesoria#w nil ) 
                             )))))
	);cond

        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w parametr#w akcesoria#w dane#w /
		   nastawa#w nastawa1#w p#w d#w f#w text#w wyd#w zwrot#w kierTu#w )

;i#w ("P2>P1")
;rozmiar#w (("d1mm" "100") ("Amm" "137") ("Bmm" "12") ("kg" "0.2"))
;kierunki#w (("P1" "d1mm" "600.00" (-348.838 176.616 0.0) "P2" "d1mm" "600.00" (-348.838 179.356 0.0)))
;dane#w (("1" "12" "60")...)
;parametr#w "200"
;akcesoria#w (("WentyleSpiroKU_Nastawy" "1") ("WentyleSpiroKU_Gniazdo" "0"))

(if (not dane#w)
    (setq zwrot#w (list "" (strcat "0;Brak danych o spadkach cinie dla rozmiaru " parametr#w) ))

;else - jeli rozmiar uzbrojony w liczenie dPa
(progn

(setq nastawa#w (cadar akcesoria#w))	

		(if (member parametr#w '("100"))
		(cond ((member nastawa#w '("0"))  (setq nastawa1#w "nast.-15mm."))
		      ((member nastawa#w '("1"))  (setq nastawa1#w "nast.-10mm."))
		      ((member nastawa#w '("2"))  (setq nastawa1#w "nast.-5mm."))
		      ((member nastawa#w '("3"))  (setq nastawa1#w "nast.0mm."))
		      ((member nastawa#w '("4"))  (setq nastawa1#w "nast.5mm."))
		      ((member nastawa#w '("5"))  (setq nastawa1#w "nast.10mm."))
		));cond/if

		(if (member parametr#w '("125"))
		(cond ((member nastawa#w '("0"))  (setq nastawa1#w "nast.-10mm."))
		      ((member nastawa#w '("1"))  (setq nastawa1#w "nast.-7mm."))
		      ((member nastawa#w '("2"))  (setq nastawa1#w "nast.-5mm."))
		      ((member nastawa#w '("3"))  (setq nastawa1#w "nast.0mm."))
		      ((member nastawa#w '("4"))  (setq nastawa1#w "nast.5mm."))
		      ((member nastawa#w '("5"))  (setq nastawa1#w "nast.10mm."))
		));cond/if

		(if (member parametr#w '("160"))
		(cond ((member nastawa#w '("0"))  (setq nastawa1#w "nast.-10mm."))
		      ((member nastawa#w '("1"))  (setq nastawa1#w "nast.-5mm."))
		      ((member nastawa#w '("2"))  (setq nastawa1#w "nast.0mm."))
		      ((member nastawa#w '("3"))  (setq nastawa1#w "nast.5mm."))
		      ((member nastawa#w '("4"))  (setq nastawa1#w "nast.10mm."))
		      ((member nastawa#w '("5"))  (setq nastawa1#w "nast.15mm."))
		));cond/if

		(if (member parametr#w '("200"))
		(cond ((member nastawa#w '("0"))  (setq nastawa1#w "nast.-3mm."))
		      ((member nastawa#w '("1"))  (setq nastawa1#w "nast.0mm."))
		      ((member nastawa#w '("2"))  (setq nastawa1#w "nast.5mm."))
		      ((member nastawa#w '("3"))  (setq nastawa1#w "nast.10mm."))
		      ((member nastawa#w '("4"))  (setq nastawa1#w "nast.15mm."))
		      ((member nastawa#w '("5"))  (setq nastawa1#w "nast.20mm."))
		));cond/if

(setq kierTu#w (car kierunki#w))

               ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w)
		(setq d#w  (/ (atof (cadr (assoc d#w rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4))  ;[m2]
		(setq text#w (strcat "0;Zawr wywiewny," nastawa1#w))

(setq wyd#w (atof (nth 2 kierTu#w)) ) ;[m3/h]

;wywoanie odczytu dPa z tablicy/wykresu
;(Nastawa, Wyd[m3/h], DPa[Pa])
(setq zwrot#w (LiczyPa_odczytDPa#w (itoa (+ (atoi nastawa#w) 1)) (rtos wyd#w 2 12) dane#w))

(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

));progn-else/if parametr#w

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 






