;----------------------------------------------------
;procedura gwna obliczajca spadki cinie elementu
(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w kiery#w i#w j#w zwrot#w zwrotObi#w
                    figura#w akcesoria#w
		    dane_SKHnawiew#w dane_SKHwywiew#w dane_SKVnawiew#w dane_SKVwywiew#w) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w
;  rozmiar#w  (("d1mm" "100") ("obw.m" "0.314") ("pole.m2" "0.008"))
;  kierunki#w (("P1" "d1mm" "100.00" (34.8437 30.4185 0.0) 
;               "P2" "d1mm" "100.00" (47.1028 30.4185 0.0)) 
;  kiery#w    ("P1>P2")
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  

;zaadowanie danych pod odpowiednie zmienne



(foreach i#w wszystkieKierPa#w
(cond

;Nawiew
((and (not dane_nawiew#w)
      (equal i#w '("P2>P1")))
      (progn (load (strcat sciezkaPlik#w plik#w "_SKHnawiew.lsp"))(setq dane_SKHnawiew#w (obliczPa1#w)) 
	     (load (strcat sciezkaPlik#w plik#w "_SKVnawiew.lsp"))(setq dane_SKVnawiew#w (obliczPa1#w)) 
))
;Wywiew
((and (not dane_wywiew#w)
      (equal i#w '("P1>P2")))
      (progn (load (strcat sciezkaPlik#w plik#w "_SKHwywiew.lsp"))(setq dane_SKHwywiew#w (obliczPa1#w)) 
	     (load (strcat sciezkaPlik#w plik#w "_SKVwywiew.lsp"))(setq dane_SKVwywiew#w (obliczPa1#w)) 
))

));cond/foreach



;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())
 
(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
	      rozmiar#w  (cadr i#w) 
              kiery#w    (caddr i#w)
              kierunki#w (cadddr i#w)
	      figura#w (cdr (assoc 2 (entget obi#w )))
	      figura#w (substr figura#w (- (strlen figura#w) 1)) )
	(setq p#w '())
	(while kiery#w (setq p#w     (append p#w (list (list (car kiery#w))))
			     kiery#w (cdr kiery#w)))
	(setq kiery#w p#w)

	(setq zwrotObi#w '())
	(foreach j#w kiery#w
	(progn
	(cond

	;Nawiew
	((and (equal j#w '("P2>P1")) (member figura#w '("11" "12" "21")))
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w dane_SKHnawiew#w) )))))
	;Nawiew
	((and (equal j#w '("P2>P1")) (member figura#w '("14" "24")))
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w dane_SKVnawiew#w) )))))

	;Wywiew
	((equal j#w '("P1>P2")) 
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w dane_SKHwywiew#w) )))))
	;Wywiew
	((equal j#w '("P1>P2")) 
	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w dane_SKVwywiew#w) )))))
	);cond
	));progn/foreach j#w
        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o spadkach!") 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!"))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie
(defun liczyPa#w ( i#w rozmiar#w kierunki#w dane#w / listaZeStr>#w dmz#w c#w
                   p#w pp#w p1#w p2#w error#w text#w
                   kolejnosc#w d#w dl#w wyd#w
		   kierTu#w j#w zwrot#w)

;  i#w ("P1>P2")
;  rozmiar#w  (("d1mm" "200") ("Dmm" "414") ("Hmm" "115") ("hmm" "30"))
;  kierunki#w (("P1" "d1mm" "400.00" (66.2094 16.0646 0.0) "P2" "d1mm" "400.00" (66.2094 7.56463 0.0)))
;  dane#w (("100" "75" "4")...)

		;lokalna zwraca list z lancucha "aaaaa>bbb"
                (defun listaZeStr>#w ( x#w / p#w i#w t#w liczba#w wynik#w )
		      (setq p#w x#w   i#w 1  liczba#w ""  wynik#w '()) 
		      (while (/= (substr x#w i#w 1) ">") (setq i#w (+ i#w 1)))
		      (setq wynik (list (substr x#w 1 (- i#w 1))  (substr x#w  (+ i#w 1)) ))
		);defun lokalnej

(setq p#w (listaZeStr>#w (car i#w)) p1#w (car p#w) p2#w (cadr p#w))
(foreach j#w kierunki#w
(if (and (= (nth 0 j#w) p1#w) (= (nth 4 j#w) p2#w))(setq kierTu#w j#w)))

		;wycignicie danych do bezporednich oblicze
		(setq d#w   (strcat (cadr (assoc "Rozmiar" rozmiar#w))(cadr (assoc "d1mm" rozmiar#w))) ;[mm]
		      wyd#w (atof (nth 2 kierTu#w))		;[m3/h]
		      text#w "0;Nawiewnik")

(cond ((= p1#w "P2")(setq text#w (strcat text#w "Nawiew")))
      ((= p1#w "P1")(setq text#w (strcat text#w "Wywiew"))) )

;wywoanie odczytu dPa z tablicy/wykresu
(if (not error#w) 			
(setq zwrot#w (LiczyPa_odczytDPa#w  d#w 
    		                    (rtos wyd#w 2 12)
			            dane#w) ));setq/if not error#w

(if (and text#w  (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))
(if (and error#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) error#w)))

zwrot#w   ;'("35" "Trjn.przelot") 
	  ;lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun

