;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
;ELEMENT jednokierunkowy

(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w rozmiar#w i#w j#w zwrot#w zwrotObi#w kiery#w
		    figura#w akcesoria#w parametr#w  
		    daneZmniejsz#w daneZwieksz#w dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w      
;  rozmiar#w  (("A mm" "100") ("B mm" "200") ("A1 mm" "80") ("B1 mm" "100") ("L mm" "300") ("E mm" "25"))
;  kierunki#w (("P1" "axbmm" "200" (271.027 227.321 0.0) "P2" "a1xb1mm" "200" (301.027 226.321 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;zaadowanie danych pod odpowiednie zmienne
(foreach i#w wszystkieKierPa#w
(progn
;Zmniejsza
(if (not daneZmniejsz#w)(progn (load (strcat sciezkaPlik#w plik#w "_zmniejsza.lsp"))
                            (setq daneZmniejsz#w (obliczPa1#w)) ))
;Zwiksza
(if (not daneZwieksz#w)(progn (load (strcat sciezkaPlik#w plik#w "_zwieksza.lsp"))
                           (setq daneZwieksz#w (obliczPa1#w)) ))
));progn/foreach


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())
 
(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
	      rozmiar#w  (cadr i#w) 
              kiery#w    (caddr i#w)
              kierunki#w (cadddr i#w) )

        (setq kiery#w (list kiery#w))   

	(setq zwrotObi#w '())
	(foreach j#w kiery#w
	(progn

	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneZmniejsz#w daneZwieksz#w) ))))
	));progn/foreach j#w
        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P3" "P2>P3") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P3" "P1>P3") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P3>P1" "P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1" "P3>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w daneZmniejsz#w daneZwieksz#w / dane#w a#w b#w a1#w b1#w l-2e#w kat#w
                   p#w pp#w p1#w p2#w error#w text#w kierTu#w j#w zwrot#w rozmrozm#w f1dof2#w f#w f1#w
 		   dzeta#w reszta#w f#w wyd#w v#w ro#w dPa#w)

;i#w ("P2>P1") lub ("P1>P2")
;rozmiar#w (("A mm" "100") ("B mm" "200") ("A1 mm" "80") ("B1 mm" "100") ("L mm" "300") ("E mm" "25"))
;kierunki#w (("P1" "axbmm" "200" (271.027 227.321 0.0) "P2" "a1xb1mm" "200" (301.027 226.321 0.0)))
;dane#w (gdy zwiksza(list "1" "0.1" "0.65") gdy zmniejsza(list "10" "0.1" "1.5") ...)

(setq p#w (car i#w) p1#w (substr p#w 1 2) p2#w (substr p#w 4 2))
(foreach j#w kierunki#w
(if (and (= (nth 0 j#w) p1#w) (= (nth 4 j#w) p2#w))(setq kierTu#w j#w)))


	(cond
	((member (car i#w) '("P1>P2"))
	     (progn
		(setq a#w  (atof (cadr (nth 0 rozmiar#w)))
		      b#w  (atof (cadr (nth 1 rozmiar#w)))
		      a1#w (atof (cadr (nth 2 rozmiar#w)))
		      b1#w (atof (cadr (nth 3 rozmiar#w)))
		       f#w (* a#w b#w)
		      f1#w (* a1#w b1#w))
	     ));progn+

	((member (car i#w) '("P2>P1"))
	     (progn
		(setq a#w  (atof (cadr (nth 2 rozmiar#w)))
		      b#w  (atof (cadr (nth 3 rozmiar#w)))
		      a1#w (atof (cadr (nth 0 rozmiar#w)))
		      b1#w (atof (cadr (nth 1 rozmiar#w)))
		       f#w (* a#w b#w)
		      f1#w (* a1#w b1#w))
	     ));progn+
	);cond

	(setq l-2e#w (- (atof (cadr (nth 4 rozmiar#w))) (* 2 (atof (cadr (nth 5 rozmiar#w)))))
	       kat#w (* (/ (atan (/ (abs (- a1#w a#w)) l-2e#w)) pi) 180) )

	;zabezpieczenie zgodnoci kierunku rozwarcia i wartoci kta rozwarcia
	(cond
	((and (> (- a#w a1#w) 0) (< (- b#w b1#w) 0))(setq error#w "0;Przeciwne kty rozwarcia!"))
	((and (< (- a#w a1#w) 0) (> (- b#w b1#w) 0))(setq error#w "0;Przeciwne kty rozwarcia!"))

	((= a#w a1#w)(setq error#w "0;Kt poza <10-30stopni>!"))
	((and (> a#w a1#w)(or (< kat#w 10.0) (> kat#w 30.0)))(setq error#w "0;Kt poza <10-30stopni>!"))
	((and (< a#w a1#w)(or (< kat#w 20.0) (> kat#w 30.0)))(setq error#w "0;Kt poza <20-30stopni>!"))
	);cond


(if error#w (setq zwrot#w (list "" error#w))

;else - obliczenia
(progn

(cond

;Zmniejsza
;(Kt [stopnie], stosunekF2/F1, Dzeta)
((>= a#w a1#w)
     (progn     (setq f1dof2#w (rtos (/ f1#w f#w) 2 3)
                      dane#w daneZmniejsz#w
                      rozmrozm#w (rtos kat#w 2 2)
		      text#w "0;RedukcjaZmniej.")
     ));progn+

;Zwieksza
;(Zawsze "1", stosunekF1/F2, Dzeta)
((< a#w a1#w)
     (progn     (setq f1dof2#w (rtos (/ f#w f1#w) 2 3)
                      dane#w daneZwieksz#w
                      rozmrozm#w "1"
		      text#w "0;RedukcjaZwieksz.")
     ));progn+
);cond

(setq zwrot#w (LiczyPa_odczytDPa#w rozmrozm#w f1dof2#w dane#w))

	(setq dzeta#w   (car zwrot#w)
	      reszta#w (cadr zwrot#w))
				 ;pole na wlocie do redukcji
	(if (/= dzeta#w "")(setq f#w   (/ f#w 1000000)           ;[m2] 
				 wyd#w (/ (atof (nth 2 kierTu#w)) 3600)  ;[m3/s]
				 v#w   (/ wyd#w f#w)                     ;[m/s]
				 ro#w  1.2 ;[kg/m3] gsto powietrza
				dPa#w  (* (atof dzeta#w) (/ (* ro#w (* v#w v#w)) 2)) ;[Pa]
				zwrot#w (list  (rtos dPa#w 2 2) reszta#w)
			   ));setq/if

));progn else/if error#w


(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 


