;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
;ELEMENT (jednokierunkowy) W KTRYM dPa ZALENE od innego parametru ni kierunek

(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w rozmiar#w i#w j#w zwrot#w zwrotObi#w kiery#w
		    figura#w akcesoria#w parametr#w 
		    dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w      
;  rozmiar#w  (("A mm" "100") ("B mm" "200") ("A1 mm" "80") ("B1 mm" "100") ("L mm" "300") ("E mm" "25"))
;  kierunki#w (("P1" "axbmm" "200" (271.027 227.321 0.0) "P2" "a1xb1mm" "200" (301.027 226.321 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;rekonstrukcja wszystkieKierPa#w poniewa na wybr wykresu ma wpyw inna wielko 
;ni kierunki przepywu
(setq wszystkieKierPa#w '())
(foreach i#w listaDoPa#w (setq wszystkieKierPa#w 
                         (append wszystkieKierPa#w (list (cadar (cadr i#w))))))


;zaadowanie danych z pliku
(if (not dane#w)
    (progn (load (strcat sciezkaPlik#w plik#w "_PaData.lsp"))
           (setq dane#w (obliczPa1#w)) ))

;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())

(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
              kiery#w     (caddr i#w)
	      rozmiar#w   (cadr i#w) 
 	      kierunki#w  (cadddr i#w)
	      akcesoria#w (cadr (cddddr i#w)) )

	(setq zwrotObi#w '())
        (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w 
                                        akcesoria#w dane#w ) 
                             ))))

        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun










;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w akcesoria#w dane#w /
		   nastawa#w nastawa1# wp#w a#w b#w v#w f#w text#w wyd#w zwrot#w kierTu#w )

;i#w ("P2>P1")
;rozmiar#w (("A mm" "800") ("B mm" "300"))
;kierunki#w (("P2" "axbmm" "600.00" (628.674 123.741 0.0) "P1" "axbmm" "600.00" (503.674 123.741 0.0)))
;dane#w (("15" "0.13" "12")...)
;akcesoria#w (("WentyleProstokatneSQDSI_Nastawy" "3"))

(if (not dane#w)
    (setq zwrot#w (list "" (strcat "0;Brak danych o spadkach cinie dla rozmiaru " parametr#w) ))

;else - jeli rozmiar uzbrojony w liczenie dPa
(progn

(setq nastawa#w (cadadr akcesoria#w))
(cond	
		      ((member nastawa#w '("0"))  (setq nastawa#w "15"))
		      ((member nastawa#w '("1"))  (setq nastawa#w "20"))
		      ((member nastawa#w '("2"))  (setq nastawa#w "25"))
		      ((member nastawa#w '("3"))  (setq nastawa#w "30"))
		      ((member nastawa#w '("4"))  (setq nastawa#w "35"))
		      ((member nastawa#w '("5"))  (setq nastawa#w "40"))
		      ((member nastawa#w '("6"))  (setq nastawa#w "45"))
		      ((member nastawa#w '("7"))  (setq nastawa#w "50"))
		      ((member nastawa#w '("8"))  (setq nastawa#w "55"))
		      ((member nastawa#w '("9"))  (setq nastawa#w "60"))
		      ((member nastawa#w '("10"))  (setq nastawa#w "65"))
		      ((member nastawa#w '("11"))  (setq nastawa#w "70"))
		      ((member nastawa#w '("12"))  (setq nastawa#w "75"))
		      ((member nastawa#w '("13"))  (setq nastawa#w "80"))
		      ((member nastawa#w '("14"))  (setq nastawa#w "85"))
		      ((member nastawa#w '("15"))  (setq nastawa#w "90"))
);cond
(setq kierTu#w (car kierunki#w))

		;wycignicie danych do bezporednich oblicze
		(setq a#w   (/ (atof (cadr (nth 0 rozmiar#w))) 1000)  ;[m]
		      b#w   (/ (atof (cadr (nth 1 rozmiar#w))) 1000)  ;[m]
		      wyd#w (/ (atof (nth 2 kierTu#w)) 3600)  ;[m3/s]
		      v#w   (/ wyd#w (* a#w b#w))                     ;[m/s]
		      text#w (strcat "0;Przepustnica, Nast." nastawa#w "st."))


;wywoanie odczytu dPa z tablicy/wykresu
;(Kt otwarcia, V[m/s], DPa[Pa])
(setq zwrot#w (LiczyPa_odczytDPa#w  nastawa#w (rtos v#w 2 12) dane#w))

(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

));progn-else/if parametr#w

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 





