;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
;ELEMENT jednokierunkowy

(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w rozmiar#w i#w j#w zwrot#w zwrotObi#w kiery#w
		    figura#w akcesoria#w parametr#w  
		    daneZmniejsz#w daneZwieksz#w dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w      
;  rozmiar#w  (("A mm" "100") ("B mm" "200") ("A1 mm" "80") ("B1 mm" "100") ("L mm" "300") ("E mm" "25"))
;  kierunki#w (("P1" "axbmm" "200" (271.027 227.321 0.0) "P2" "a1xb1mm" "200" (301.027 226.321 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())
 
(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
	      rozmiar#w  (cadr i#w) 
              kiery#w    (caddr i#w)
              kierunki#w (cadddr i#w) )

        (setq kiery#w (list kiery#w))   

	(setq zwrotObi#w '())
	(foreach j#w kiery#w
	(progn

	     (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		               (liczyPa#w j#w rozmiar#w kierunki#w daneZmniejsz#w daneZwieksz#w) ))))
	));progn/foreach j#w
        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P3" "P2>P3") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P3" "P1>P3") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P3>P1" "P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1" "P3>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w daneZmniejsz#w daneZwieksz#w / dane#w a#w b#w a1#w b1#w l-2e#w kat#w
                   p#w pp#w p1#w p2#w error#w text#w kierTu#w j#w zwrot#w rozmrozm#w f1dof2#w f#w f1#w
 		   dzeta#w reszta#w f#w wyd#w v#w ro#w dPa#w)

;i#w ("P2>P1") lub ("P1>P2")
;rozmiar#w (("A mm" "100") ("B mm" "200") ("A1 mm" "80") ("B1 mm" "100") ("L mm" "300") ("E mm" "25"))
;kierunki#w (("P1" "axbmm" "200" (271.027 227.321 0.0) "P2" "a1xb1mm" "200" (301.027 226.321 0.0)))
;dane#w (gdy zwiksza(list "1" "0.1" "0.65") gdy zmniejsza(list "10" "0.1" "1.5") ...)

(setq p#w (car i#w) p1#w (substr p#w 1 2) p2#w (substr p#w 4 2))
(foreach j#w kierunki#w
(if (and (= (nth 0 j#w) p1#w) (= (nth 4 j#w) p2#w))(setq kierTu#w j#w)))


		(setq a#w  (atof (cadr (nth 0 rozmiar#w)))
		      b#w  (atof (cadr (nth 1 rozmiar#w)))
		      f#w  (* a#w b#w))

     ;(Kt [stopnie], stosunekF2/F1, Dzeta)
     (setq text#w "0;Wyrzutnia")

	(setq dzeta#w   "1.15"
	      reszta#w text#w)
				 ;pole na wlocie do redukcji
	(if (/= dzeta#w "")(setq f#w   (/ f#w 1000000)           ;[m2] 
				 wyd#w (/ (atof (nth 2 kierTu#w)) 3600)  ;[m3/s]
				 v#w   (/ wyd#w f#w)                     ;[m/s]
				 ro#w  1.2 ;[kg/m3] gsto powietrza
				 dPa#w   (* (atof dzeta#w) (/ (* ro#w (* v#w v#w)) 2)) ;[Pa]
				 zwrot#w (list  (rtos dPa#w 2 2) reszta#w)
			   ));setq/if


(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 


