;----------------------------------------------------
;procedura gwna obliczajca spadki cinie elementu
(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w kiery#w i#w j#w zwrot#w zwrotObi#w
                    figura#w akcesoria#w
		    daneSR#w daneAB#w) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w
;  rozmiar#w  (("d1mm" "100") ("obw.m" "0.314") ("pole.m2" "0.008"))
;  kierunki#w (("P1" "d1mm" "100.00" (34.8437 30.4185 0.0) 
;               "PX;47.10284;30.41851;" "d1mm" "100.00" (47.1028 30.4185 0.0)) 
;	       ("PX;47.1284;30.41851;" "d1mm" "200.00" (47.1028 30.4185 0.0) .. ))
;  kiery#w    ("P1>PX;47.10284;30.41851;" "PX;47.10284;30.41851;>P2;")
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;zaadowanie danych z pliku
;PR
(if (not daneSR#w)
    (progn (load (strcat sciezkaPlik#w plik#w "_PaData.lsp"))
           (setq daneSR#w (obliczPa1#w)) ))

(if (not daneAB#w)
	(setq daneAB#w 
	(list "1000000" "920000" "850000" "720000" "700000" "610000" "560000" "510000" "460000" 
	"410000" "400000" "350000" "315000" "280000" "260000" "240000" "220000" "200000" "180000" "160000" "145000" 			"130000" "120000" "110000" "100000" "90000" "80000" "74000" "67500" "60000" "55000" "50000" "45000" "41000" 
	"37500" "34000" "30000" "28000" "25000" "23000" "20000" "18000" "16500" "15500" "13500" "12100" "11200" 
	"10000" "9200" "8500" "7500" "7000" "6200" "5600" "5100" "4500" "4100" "3800" "3500" "3100" "2800" "2600" 
	"2350" "2100" "1900" "1750" "1600" "1350" "1250" "1200" "1100" "975" "875" "800" "720" "660" "600" "550" "480" 			"440" "400" "360" "340" "300" "270" "245" "220" "200" "180" "170" "155" "135" "125" "115" "102" "95" "85" "78"
	"70" "64" "58" "52" "47" "43" "38" "35" "32" "30" "28" "24" "22" "20" "18" "16" "14.5" "13.5" "12" "11" "10" 			"9" "8" "7" "6.5" "6" "5.5" "5")))


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())
 
(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
	      rozmiar#w  (cadr i#w) 
              kiery#w    (caddr i#w)
              kierunki#w (cadddr i#w) )
	(setq p#w '())
	(while kiery#w (setq p#w     (append p#w (list (list (car kiery#w))))
			     kiery#w (cdr kiery#w)))
	(setq kiery#w p#w)


	(setq zwrotObi#w '())
	(foreach j#w kiery#w
	(progn

	;PR
	(setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		          (liczyPa#w jm_wsp#w j#w rozmiar#w kierunki#w daneSR#w) ))))

	));progn/foreach j#w
        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>PX;64.54131;30.41851;") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("PX;64.54131;30.41851>P2") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie
(defun liczyPa#w ( jm_wsp#w i#w rozmiar#w kierunki#w dane#w / listaZeStr>#w dmz#w c#w
                    p#w pp#w p1#w p2#w error#w text#w
                   kolejnosc#w d#w a#w b#w dh#w dl#w wyd#w
		   kierTu#w j#w zwrot#w wspPa#w)

;  rozmiar#w  (("A mm" "100") ("B mm" "200"))

;korekta rozmiar#w
(setq rozmiar#w (list (list  
(strcase (strcat (substr (caar rozmiar#w) 1 1) "x" (substr (caadr rozmiar#w) 1 1) "mm") T)
(cadar rozmiar#w) (cadadr rozmiar#w) 
)))

;  i#w ("P1>P2")
;  rozmiar#w (("axbmm" "100" "200"))
;  kierunki#w (("P1" "axbmm" "200" (221.68 200.508 0.0) "P2" "axbmm" "200" (321.68 200.508 0.0)))
;  dane#w (("74" "6.5" "0.007")...)

		;lokalna zwraca list z lancucha "aaaaa>bbb"
                (defun listaZeStr>#w ( x#w / p#w i#w t#w liczba#w wynik#w )
		      (setq p#w x#w   i#w 1  liczba#w ""  wynik#w '()) 
		      (while (/= (substr x#w i#w 1) ">") (setq i#w (+ i#w 1)))
		      (setq wynik (list (substr x#w 1 (- i#w 1))  (substr x#w  (+ i#w 1)) ))
		);defun lokalnej

(setq p#w (listaZeStr>#w (car i#w)) p1#w (car p#w) p2#w (cadr p#w))
(foreach j#w kierunki#w
(if (and (= (nth 0 j#w) p1#w) (= (nth 4 j#w) p2#w))(setq kierTu#w j#w)))

		;wycignicie danych do bezporednich oblicze
		(setq p#w   (nth 1 kierTu#w)
                      d#w   p#w
                      d#w   (assoc d#w rozmiar#w)
		      a#w   (atof (cadr  d#w)) 			
		      b#w   (atof (caddr d#w)) 			
		      dh#w  (/ (* 2 (* a#w b#w)) (+ a#w b#w))   ;[mm]
		      wyd#w (atof (nth 2 kierTu#w))		;[m3/h]	
		         p1#w  (nth 3 kierTu#w)
		         p2#w  (nth 7 kierTu#w)
		         dl#w  (/ (/ (distance p1#w p2#w) (atof jm_wsp#w)) 1000.0) ;[m]
		         text#w "0;Kana")


;wykorzystujc zmienn procedury nadrzdnej obi#w oraz wydajno wyd#w
;okrela wspPa#w - wspczynnik przeliczenia spadku c. 
;w zalenoci od rodzaju wewntrznej powierzchni kanau ClimaverPlus/ClimaverBlack
(setq wspPa#w "1.0")
(if (= (strcase (cdar (cdadr (assoc -3 (entget obi#w '("SPECJALNE_W"))))) T) "_black")
		(cond
		((<= wyd#w 2500.0) (setq wspPa#w "1.5"))
		((and (> wyd#w 2500.0)(<= wyd#w 20000.0)) (setq wspPa#w "1.68"))
		((and (> wyd#w 20000.0)(<= wyd#w 50000.0)) (setq wspPa#w "2.0"))
		((> wyd#w 50000.0) (setq wspPa#w "2.5"))
		(T (setq wspPa#w "1.70"))
		));cond/if 
(if (= (strcase (cdar (cdadr (assoc -3 (entget obi#w '("SPECJALNE_W"))))) T) "_a2black")(setq wspPa#w "1.35"))


 ;nowa wydajno obliczeniowa < uwzgldnia stosunek bokw z nomogramu, daneAB#w - zmienna z nadrzdnej procedury
 (if (> wyd#w 0) (progn
 (if (> b#w a#w)(setq p#w a#w  a#w b#w  b#w p#w))
 (setq p#w (atoi (rtos (/ a#w b#w) 2 0)))
 (cond  ((= p#w 1)(setq pp#w 2))
        ((= p#w 2)(setq pp#w 4))
        ((= p#w 3)(setq pp#w 5))
        ((= p#w 4)(setq pp#w 7))
        (T        (setq pp#w 8)) )   ;stosunek bokw 5.0 i wicej
 (setq p#w daneAB#w)
 (while (< wyd#w (atof (car p#w))) (setq p#w (cdr p#w)))
 (if (and p#w (> (length p#w) pp#w)) (setq wyd#w (atof (nth pp#w p#w))))
 ));progn/if > wyd#w


;wywoanie odczytu dPa z tablicy/wykresu ->zwraca [0.1Pa/m]
;rednica hydraul[mm], Przepyw[m3/h], DPa[0.1Pa/m]
(if (not error#w) 
(setq zwrot#w (LiczyPa_odczytDPa#w  (rtos dh#w 2 12)
    		                    (rtos wyd#w 2 12)
			            dane#w) ));setq/if not error#w

;obliczenie liniowego dPa
(if (/= (car zwrot#w) "")
(progn
(setq dmz#w (getvar "DIMZIN"))(setvar "DIMZIN" 8)
(setq c#w     (atof (car zwrot#w))

      ;tu korekta, poniewa pocedura liczca zwrcia dziesit cz Pa/m
      c#w     (* 10 c#w)

      ;tu uwzgldnienie wspczynnika od rodzaju wewntrznej powierzchni kanau ClimaverPlus/ClimaverBlack
      c#w     (* (atof wspPa#w) c#w)

      c#w     (* dl#w c#w)
      c#w     (rtos c#w 2 2)
      zwrot#w (list c#w (cadr zwrot#w)) )
(setvar "DIMZIN" dmz#w)
));progn/if/=car zwrot#w""

(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))
(if (and error#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) error#w)))

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun

